
$placeHolderStr = "FurionExample"
$createInfo     = "//  Created by $AUTHOR on $DATE."
$copyrightInfo  = "//  Copyright © $YEAR $PROJECT. All rights reserved."
$zipCodeUri = "https://git.huya.com/chenguohao2/FurionTemplateResource/raw/master/iOS/FurionExample.zip"
class ProjectGenerater

  def self.fetchExampleCode

  end

  def self.setupProject(projPath,newName)
    Find.find(projPath) do |path|
      puts "[o]"+path
      newPath = path.gsub($placeHolderStr,newName)
      puts "[*]"+newPath
      if File.file?(path)
        copyUpdateFile(path,newPath,$placeHolderStr,newName)
      else
        Dir.mkdir(newPath)
      end
    end
  end


  def self.copyUpdateFile(oldPath,newPath,oldName,newName)
    File.open(newPath, "w") do |out|
      File.foreach(oldPath) do |line|

        content = self.updateCopyRight(line,newName)
        content = self.updateCreatedInfo(content)
        if content.include?oldName
          newLine = content.gsub(oldName,newName)
          out.puts newLine
        else
          out.puts content
        end
      end
    end
  end

  def self.updateCopyRight(content,projName)
     if content.include? $copyrightInfo
       current_year = Time.new.year
       year_content = content.sub("$YEAR",String(current_year))
       result = year_content.sub("$PROJECT",projName)
       return result
     end
    return content
  end

  def self.updateCreatedInfo(content)
    if content.include?  $createInfo
      curTime = Time.now.strftime("%Y/%m/%d")
      time_content = content.sub("$DATE",curTime)
      author = Etc.getpwuid(Process.uid).name
      result = time_content.sub("$AUTHOR",author)
      return result
    end
    return content
  end

end
